class Architect
  # Build virtual machines
  class VirtualMachineBuilder
    require 'ForemanVM'

    # Return true if a virtual machine named [+fqdn+] exists.
    def self.exists?(fqdn)
      ForemanVM.new.vm_exists? fqdn
    end

    # Build a virtual machine
    def self.build(spec)
      fqdn = spec['fqdn']

        puts "Creating #{fqdn}"
        if options[:dry_run]
          puts '(skipping due to --dry-run)'
          next
        end
        vm = ForemanVM.new
        vm.name = spec['name']
        vm.buildspec = spec
        vm.create
      end
    end
  end
end