class Architect
  class Plan

    class InvalidPlanException < Exception
    end

    require 'yaml'

    def initialize(path)
      case path.kind_of?
      when String
        @yaml = YAML.load_file(path)
      when Hash
        @yaml = path
      else
        raise ArgumentError
      end

      validate
    end

    def to_s
      @yaml
    end

    def instances
      @yaml['instances']
    end

    private

    def validate
      problems = []
      problems.push 'Version number missing' unless @yaml.has_key? 'version'
      problems.push 'Wrong version number' unless @yaml['version'] == 1
      unless problems.empty?
        raise InvalidPlanException, "Errors found in the plan:\n  * " + problems.join("\n  * ")
      end
    end
  end
end
