require 'architect/plugin'

# A sample plugin to say "hello world" at every opportunity
class HelloWorldPlugin < Architect::Plugin

  def initialize
    @name = 'hello_world'
  end

  def configure(config_hash)
    @config = OpenStruct.new({ hello: 'world', quiet: false }.merge(config_hash))
    @quiet = @config[:quiet]
    say 'hello_world: configured'
  end

  # Check to see if any actions need to be taken, and return
  # a list of Architect::ChangeRequest objects for each proposed
  # action
  def check
    say 'hello_world: checking'
    []
  end

  # Ask questions during the design of a new plan; i.e. when
  # architect --design is called.
  def design
    say 'hello_world: designing'
  end

  # Parse a YAML plan file and perform validation.
  def plan(yaml)
    say 'hello_world: planning'
  end

  # Execute the proposed actions based on the current plan.
  def execute
    say 'hello_world: executing'
  end

  private

  # Print a message to the screen
  def say(message)
    puts message unless @quiet
  end
end