# Miscellaneous utility functions
module FVMUtil
  # Given an FQDN, return the shortname
   def shortname(fqdn)
    fqdn.sub(/\..*/, '') 
  end

  # Given an amount in bytes, return the human-readable version in GiB
  def gigabytes(s)
    if s.to_i < 1073741824
      mb = s.to_f / 1024 / 1024
      sprintf '%0.0f MiB', mb
    else
      gb = s.to_f / 1024 / 1024 / 1024
      sprintf '%0.0f GiB', gb
    end
  end 
end
